#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=prog.ico
#AutoIt3Wrapper_outfile=MDT.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=MultiDownloadTool
#AutoIt3Wrapper_Res_Fileversion=1.3.0.0
#AutoIt3Wrapper_Res_LegalCopyright=by Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <GuiStatusBar.au3>
#include <ListViewConstants.au3>
#include <Misc.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

Opt('GUIOnEventMode', 1)
Opt('GUICloseOnESC', 0)

Global $sTitle = 'Multi-Download-Tool v1.3     ' & Chr(169) & ' by Oscar (www.autoit.de)'
Global $sInifile = @ScriptDir & '\MDT.ini'
Global $aDownloads = IniReadSection($sInifile, 'Downloads')
If @error Then Exit MsgBox(0, $sTitle, 'Inidatei nicht gefunden bzw. fehlerhaft!')
Global $iStop = False, $iStopAll = False
$hGui = GUICreate($sTitle, 480, 420)
GUISetIcon(@ScriptDir & '\prog.ico')
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUICtrlCreateGroup('Zielverzeichnis', 5, 5, 470, 60)
GUICtrlCreateIcon('shell32.dll', -5, 15, 25, 32, 32)
$hTarget = GUICtrlCreateInput(@UserProfileDir & '\Downloads\', 50, 32, 380, 20, BitOR($ES_READONLY, $ES_AUTOHSCROLL))
$hSelect = GUICtrlCreateButton('...', 430, 31, 32, 22)
GUICtrlSetOnEvent(-1, '_SelectTarget')
GUICtrlCreateGroup('', -99, -99, 1, 1)
$LVStyle = BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS)
$ExStyle = BitOR($LVS_EX_FULLROWSELECT, $WS_EX_CLIENTEDGE, $LVS_EX_CHECKBOXES, $LVS_EX_DOUBLEBUFFER)
$hListView = GUICtrlCreateListView('Programme auswhlen...', 5, 75, 470, 175, $LVStyle, $ExStyle)
_GUICtrlListView_SetColumnWidth($hListView, 0, 440)
$contextmenu = GUICtrlCreateContextMenu($hListView)
GUICtrlCreateMenuItem('Alle markieren', $contextmenu)
GUICtrlSetOnEvent(-1, '_CheckAll')
GUICtrlCreateMenuItem('Keins markieren', $contextmenu)
GUICtrlSetOnEvent(-1, '_UnCheckedAll')
$hStart = GUICtrlCreateButton('Download starten', 5, 270, 100, 25)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetOnEvent(-1, '_StartDownload')
$hAVICopy = GUICtrlCreateAvi('shell32.dll', 170, 120, 250, 272, 60)
GUICtrlSetState($hAVICopy, $GUI_HIDE)
$hDispAct = GUICtrlCreateLabel('0%', 220, 315, 50, 20, $SS_CENTER)
$hProgrAct = GUICtrlCreateProgress(5, 330, 470, 16)
$hDispAll = GUICtrlCreateLabel('0%', 220, 355, 50, 20, $SS_CENTER)
$hProgrAll = GUICtrlCreateProgress(5, 370, 470, 16)
$hStatus = _GUICtrlStatusBar_Create($hGui)
_GUICtrlStatusBar_SetText($hStatus, '0 Programme ausgewhlt')
GUISetState()
HotKeySet('{ESC}', '_StopDownload')
HotKeySet('!{ESC}', '_StopAll')

Global $aLVItems[$aDownloads[0][0]]
For $i = 1 To $aDownloads[0][0]
	$aLVItems[$i - 1] = GUICtrlCreateListViewItem($aDownloads[$i][0], $hListView)
	GUICtrlSetOnEvent(-1, '_RefreshCounter')
Next

While 1
	Sleep(1000)
WEnd

Func _End()
	Exit
EndFunc   ;==>_End

Func _StartDownload()
	GUICtrlSetState($hStart, $GUI_DISABLE)
	ControlListView($hGui, '', $hListView, 'SelectClear')
	For $i = 0 To UBound($aLVItems) - 1
		GUICtrlSetBkColor($aLVItems[$i], 0xFFFFFF)
	Next
	GUICtrlSetData($hDispAll, '0%')
	GUICtrlSetData($hProgrAll, 0)
	Local $aCheckedIndices, $iSize, $sTargetFile, $sPath, $iPercent, $iOld, $iPercentAll, $iBytesRead, $iBreak
	$sPath = GUICtrlRead($hTarget)
	If Not FileExists($sPath) Then DirCreate($sPath)
	$aCheckedIndices = _GUICtrlListView_GetCheckedIndices($hListView)
	GUICtrlSetState($hAVICopy, $GUI_SHOW)
	GUICtrlSetState($hAVICopy, 1)
	$iStopAll = False
	For $i = 0 To UBound($aCheckedIndices) - 1
		$sDownload = $aDownloads[$aCheckedIndices[$i] + 1][1]
		GUICtrlSetData($hDispAct, '0%')
		GUICtrlSetData($hProgrAct, 0)
		_GUICtrlStatusBar_SetText($hStatus, 'Download von "' & $aDownloads[$aCheckedIndices[$i] + 1][0] & '"')
		$iSize = InetGetSize($sDownload)
		If Not @error Then
			$sTargetFile = $sPath & StringRegExpReplace($sDownload, '.+\/(.+\..{3}).*', '$1')
			$iStop = False
			$hDownload = InetGet($sDownload, $sTargetFile, 1, 1)
			GUICtrlSetBkColor($aLVItems[$aCheckedIndices[$i]], 0xFFFF22)
			Do
				$iBytesRead = InetGetInfo($hDownload, 0)
				$iPercent = Int(100 / $iSize * $iBytesRead)
				If $iBytesRead <> $iOld Then
					$iOld = $iBytesRead
					_GUICtrlStatusBar_SetText($hStatus, 'Download von "' & $aDownloads[$aCheckedIndices[$i] + 1][0] & '"  (' & _ByteAutoSize($iOld) & ' / ' & _ByteAutoSize($iSize) & ')')
					GUICtrlSetData($hDispAct, $iPercent & '%')
					GUICtrlSetData($hProgrAct, $iPercent)
				EndIf
				If $iStop Or $iStopAll Then ExitLoop
				Sleep(10)
			Until InetGetInfo($hDownload, 2)
			InetClose($hDownload)
			If $iSize = FileGetSize($sTargetFile) Then
				GUICtrlSetBkColor($aLVItems[$aCheckedIndices[$i]], 0x44FF44)
				_GUICtrlListView_SetItemChecked($hListView, $aCheckedIndices[$i], False)
			Else
				GUICtrlSetBkColor($aLVItems[$aCheckedIndices[$i]], 0xFF4444)
				$iBreak += 1
			EndIf
		Else
			GUICtrlSetBkColor($aLVItems[$aCheckedIndices[$i]], 0xFF4444)
			$iBreak += 1
		EndIf
		GUICtrlSetData($hDispAct, '100%')
		GUICtrlSetData($hProgrAct, 100)
		$iPercentAll = Int(100 / UBound($aCheckedIndices) * ($i + 1 - $iBreak))
		GUICtrlSetData($hDispAll, $iPercentAll & '%')
		GUICtrlSetData($hProgrAll, $iPercentAll)
		If $iStopAll Then ExitLoop
	Next
	GUICtrlSetState($hAVICopy, 0)
	GUICtrlSetState($hAVICopy, $GUI_HIDE)
	_GUICtrlStatusBar_SetText($hStatus, 'Downloads abgeschlossen!')
	GUICtrlSetState($hStart, $GUI_ENABLE)
EndFunc   ;==>_StartDownload

Func _StopDownload()
	$iStop = True
EndFunc   ;==>_StopDownload

Func _StopAll()
	$iStopAll = True
EndFunc   ;==>_StopDownload

Func _SelectTarget()
	Local $sPath
	$sPath = FileSelectFolder('Bitte Zielverzeichnis auswhlen', GUICtrlRead($hTarget), 3, '', $hGui)
	If @error Then Return
	If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
	If FileExists($sPath) Then
		GUICtrlSetData($hTarget, $sPath)
	EndIf
EndFunc   ;==>_SelectTarget

Func _RefreshCounter()
	Local $iCount = _GUICtrlListView_GetCheckedCount($hListView)
	If $iCount > 0 Then
		GUICtrlSetState($hStart, $GUI_ENABLE)
	Else
		GUICtrlSetState($hStart, $GUI_DISABLE)
	EndIf
	GUICtrlSetData($hDispAll, '0%')
	GUICtrlSetData($hProgrAll, 0)
	GUICtrlSetData($hDispAct, '0%')
	GUICtrlSetData($hProgrAct, 0)
	For $i = 0 To UBound($aLVItems) - 1
		GUICtrlSetBkColor($aLVItems[$i], 0xFFFFFF)
	Next
	_GUICtrlStatusBar_SetText($hStatus, $iCount & ' Programm' & (($iCount = 1) ? '' : 'e') & ' ausgewhlt')
EndFunc   ;==>_RefreshCounter

Func _CheckAll()
	_GUICtrlListView_SetItemChecked($hListView, -1, True)
	_RefreshCounter()
EndFunc   ;==>_CheckAll

Func _UnCheckedAll()
	_GUICtrlListView_SetItemChecked($hListView, -1, False)
	_RefreshCounter()
EndFunc   ;==>_UnCheckedAll

Func _GUICtrlListView_GetCheckedCount($hListView)
	Local $iCount = _GUICtrlListView_GetItemCount($hListView), $iCheckedCount = 0
	If $iCount = 0 Then Return SetError(1, 0, 0)
	For $i = 0 To $iCount - 1
		$iCheckedCount += _GUICtrlListView_GetItemChecked($hListView, $i)
	Next
	Return $iCheckedCount
EndFunc   ;==>_GUICtrlListView_GetCheckedCount

Func _GUICtrlListView_GetCheckedIndices($hListView)
	Local $iCount = _GUICtrlListView_GetItemCount($hListView)
	Local $iCheckedCount = _GUICtrlListView_GetCheckedCount($hListView)
	If $iCheckedCount = 0 Then Return SetError(1, 0, 0)
	Local $aCheckedItems[$iCheckedCount]
	$iCheckedCount = 0
	For $i = 0 To $iCount - 1
		If _GUICtrlListView_GetItemChecked($hListView, $i) Then
			$aCheckedItems[$iCheckedCount] = $i
			$iCheckedCount += 1
		EndIf
	Next
	Return $aCheckedItems
EndFunc   ;==>_GUICtrlListView_GetCheckedIndices

;===============================================================================
; Function Name:   _ByteAutoSize($iSize[, $iRound][, $iFormat][, $bThousands])
; Description::    Gibt einen Bytewert in einer bestimmten Einheit zurck
; Parameter(s):    $iSize = Gre in Byte bergeben
;                  $iRound = Anzahl der Nachkommastellen (0...8)
;                  $iFormat = bestimmt den Rckgabewert
;                     0 = Automatisch (je nach bergebenen Wert)
;                     1 = in Byte
;                     2 = in KByte
;                     3 = in MByte
;                     4 = in GByte
;                  $bThousands = Rckgabe mit Tausendertrennzeichen (True/False)
; Requirement(s):  #include <String.au3>
; Author(s):       Oscar (www.autoit.de)
;===============================================================================
Func _ByteAutoSize($iSize, $iRound = 2, $iFormat = 0, $bThousands = True)
	Local $aSize[4] = [' Byte', ' KByte', ' MByte', ' GByte'], $sReturn
	If $iFormat < 0 Or $iFormat > 4 Then $iFormat = 0
	If $iRound < 0 Or $iRound > 8 Then $iRound = 2
	If Not IsBool($bThousands) Then $bThousands = False
	$iSize = Abs($iSize)
	If $iFormat = 0 Then
		For $i = 30 To 0 Step -10
			If $iSize > (2 ^ $i) Then
				$iFormat = $i / 10 + 1
				ExitLoop
			EndIf
		Next
	EndIf
	If $iFormat = 0 Then $iFormat = 1
	$sReturn = StringFormat('%.' & $iRound & 'f', Round($iSize / (2 ^ (($iFormat - 1) * 10)), $iRound))
	If $bThousands Then $sReturn = _StringAddThousandsSep($sReturn, '.', ',')
	Return $sReturn & $aSize[$iFormat - 1]
EndFunc   ;==>_ByteAutoSize

; #FUNCTION# ====================================================================================================================
; Name...........: _StringAddThousandsSep
; Description ...: Returns the original numbered string with the Thousands delimiter inserted.
; Syntax.........: _StringAddThousandsSep($sString[, $sThousands = -1[, $sDecimal = -1]])
; Parameters ....: $sString    - The string to be converted.
;                  $sThousands - Optional: The Thousands delimiter
;                  $sDecimal   - Optional: The decimal delimiter
; Return values .: Success - The string with Thousands delimiter added.
; Author ........: SmOke_N (orignal _StringAddComma
; Modified.......: Valik (complete re-write, new function name)
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; Yes
; ===============================================================================================================================
Func _StringAddThousandsSep($sString, $sThousands = -1, $sDecimal = -1)
    Local $sResult = "" ; Force string
    Local $rKey = "HKCU\Control Panel\International"
    If $sDecimal = -1 Then $sDecimal = RegRead($rKey, "sDecimal")
    If $sThousands = -1 Then $sThousands = RegRead($rKey, "sThousand")
    Local $aNumber = StringRegExp($sString, "(\D?\d+)\D?(\d*)", 1) ; This one works for negatives.
    If UBound($aNumber) = 2 Then
        Local $sLeft = $aNumber[0]
        While StringLen($sLeft)
            $sResult = $sThousands & StringRight($sLeft, 3) & $sResult
            $sLeft = StringTrimRight($sLeft, 3)
        WEnd
        $sResult = StringTrimLeft($sResult, StringLen($sThousands)) ; Strip leading thousands separator
        If $aNumber[1] <> "" Then $sResult &= $sDecimal & $aNumber[1]
    EndIf
    Return $sResult
EndFunc   ;==>_StringAddThousandsSep
